#!/usr/bin/php
<?php
/**
 * WMS automatic upgrade script.
 * Created by Alex Soloviov.
 */

$basepath = '/var/www';
require_once($basepath.'/autoload.php');
require_once('lang/' . ((isset($_SESSION['language'])) ? $_SESSION['language'] : 'english') . '.inc.php');

$repo = null;
$email = null;
$isAllowedUpgrade = false;

$upgrade_class = new upgrade("\n");

$fromPortal = (!empty($argv[1]) && $argv[1] == 'from_portal') ? true : false;

if ($fromPortal) { // Portal initialize upgrade
    try {
        $portalService = new \Wildix\Services\Portal(2);
        $portalParams  = $portalService->getUpgradeParameters();
    } catch (\Exception $e) {
    	logger($e->getMessage() . " RETURN CODE: ". $e->getCode(), "AUTOUPGRADE");
        throw new \Exception($e->getMessage(), $e->getCode());
    }

    if ( !empty($portalParams['repo']) && !empty($portalParams['email']) ) {
        $repo = $portalParams['repo'];
    	$email = $portalParams['email'];
        $isAllowedUpgrade = true;
    }

} else { // AutoUpgrade configured on PBX

    $localParams = \Wildix\Upgrade::getInstance()->getAutoUpgradeSettings();

    if ( !empty($localParams['repo']) && !empty($localParams['email']) ) {
        $repo = $localParams['repo'];
        $email = $localParams['email'];
        $isAllowedUpgrade = true;
    }
}

if($isAllowedUpgrade) {
	// perform upgrade
    if( ! $upgrade_class->performAutoUpgrade($repo, $email) ){
    	logger("Automatic upgrade finished with errors","AUTOUPGRADE");
	}
}
