//--------------------------------------
/*
 * By default disabled:
 * dialtone
 * tonezone
 * snmp
 * sip_firewall
 */
var availableDeviceSettings = {
	'wp400': {
		'snmp': true
	},
	'wp410r2': {
		'snmp': true
	},
	'wp480': {
		'snmp': true
	},
	'wp480r2': {
		'snmp': false
	},
	'wp480gr2': {
		'snmp': false
	},
	'wp480gr3': {
        'snmp': false
    },
	'wp490': {
		'snmp': true
	},
	'wp490r2': {
		'snmp': false
	},
	'wp490gr2': {
		'snmp': false
	},
	'wp490gcr2': {
		'snmp': false
	},
	'wp490gr3': {
        'snmp': false
    },
	'wp490gr4': {
		'snmp': false
	},
	'wp500': {
		'snmp': true
	},
	'wp600': {
	},

	'w-air': {
	},
	'w-air-sp': {
	},

	'w01fxs': {
	},
	'w01fxsr2': {
		'tonezone': true
	},
	'w02fxsr2': {
		'tonezone': true
	},
	'w02fxsr3': {
		'tonezone': true
	},
	'w24fxsr3': {
		'tonezone': true
	},
        'w04fxsr3': {
                'tonezone': true
        },
	'w04fxs': {
		'tonezone': true
	},
	'w08fxs': {
		'tonezone': true,
		'snmp': true
	},
	'w08fxsr2': {
        'tonezone': true
    },
	'w16fxs': {
		'tonezone': true,
		'snmp': true
	},
	'w24fxs': {
		'tonezone': true,
		'snmp': true
	},
	'w24fxsr2': {
        'tonezone': true
    },


	'w04fxo': {
		'sip_firewall': true,
		'tonezone': true
	},


	'w01bri': {
		'snmp': true,
		'sip_firewall': true
	},
	'w02bri': {
		'snmp': true,
		'sip_firewall': true
	},
	'w04bri': {
		'snmp': true,
		'sip_firewall': true
	},


	'w1pri': {
		'snmp': true,
		'sip_firewall': true
	},
	'w2pri': {
		'snmp': true,
		'sip_firewall': true
	},


	'w01gsm': {
		'sip_firewall': true
	}
}

var provDevices = {};
var stateDevices = {};

function renderDeviceModel(model) {
    return (model === 'wp490gr4' ? 'WelcomeConsole' : model);
}

jQuery(document).ready(function ($){

	$('#Main').tooltip();

	new Ajax.PeriodicalUpdater (false, 'api/v1/PBX/settings/Devices/Status/', {
	    method: 'get',
	    frequency: 10,
	    decay: 1,
	    onSuccess: function(t) {
	        var response = t.responseJSON;
	        if(response){
	        	stateDevices = response.result;
	        }
	    }
	});

	var devicesTable = $('#devicesTable').DataTable({
		select: true,
		paging: true,
    	pageLength: 25,
    	searching: true,
    	autoWidth: false,
    	serverSide: false,
    	order: [[ 3, 'asc' ]],
		buttons: [
	        'selectAll',
	        'selectNone'
	    ],
		columns: [ // column header
			{"data":"ready", "title":"", "width": "10px", "orderable": false, "render": function (data, type, full, meta) {
				var html = '';

				switch (data) {
					case 'on': html = '&nbsp;';
						break;
					case 'fwlocal': html = '<i style="color: #00a6d6;" class="fa fa-info-circle" title="'+translation['devices.FirmwareAvailable']+'"></i>';
						break;
					case 'up': html = '<i style="color: #3f7f00;" class="fa fa-refresh fa-spin" title="'+translation['devices.UpdatingDevice']+'"></i>';
						break;
					default: html = '&nbsp;';
						break;
				}
    		   	return html;
		    }},
    		{"data":"state", "title":"", "width": "15px", "orderable": false, "render": function (data, type, full, meta) {

				if(full.model == 'w01fxs'){
					return '&nbsp;';
				}else if(data){
					return '<div class="status"><i class="fa fa-circle status-available" title="'+data+'" style="line-height: 16px;font-size: 16px;"></i></div>';
				}
				return '<div class="status"><i class="fa fa-circle status-unavailable" style="line-height: 16px;font-size: 16px;"></i></div>';

		    }},
    		{"data":"vendor", "title": translation['devices.Vendor'], "orderable": false, "visible": false},
    		{"data":"model", "title": translation['devices.Model'], "orderable": true, "render": renderDeviceModel},
    		{"data":"address", "title": translation['strings.IpAddress'], className: "center", "orderable": true, "render": function (data, type, full, meta) {

    			if (!!data) {
                    return '<a href="http://'+ data +'/" target="_blank">' + data + '</a>';
                }
    			return data;
		    }},
    		{"data":"url", "title": translation['devices.Connect'], width: "80px", "orderable": true, "render": function (data, type, full, meta) {

    			if(!isCloud && !isLocal && full.address != "" && full.islocal) {
    				if(full.url != '') {
    					var newUrl = '';
    					if(/http(s)*:\/\/[^\.]+\.wildix\.com\/([^\.]+\.)+wildixin\.com\/.*?/i.test(window.location.href)){
    						// if a proxied with https://pbxs.wildix.com/:pbxdomain/
    						// need use relative url https://pbxs.wildix.com/:generateddomain/
    						newUrl = full.url.replace(/http(s)*:\/\//gi, '');
    						newUrl = '../' + newUrl.replace(/:\d+/gi, '');
    					} else {
                            newUrl = full.url;
                        }
    					return '<div class="col-center clearfix" style="width: 80px;"><i class="fa fa-stop" title="'+translation['devices.Disconnect']+'" data-ip="'+ full.address +'" ></i><a href="'+ newUrl +'" title="'+translation['devices.Open']+'" class="fa fa-external-link" target="_blank"></a></div>';
    				}

    				return '<div class="col-center clearfix" style="width: 80px;"><i class="fa fa-play" title="'+translation['devices.Connect']+'" data-ip="'+ full.address +'"></i></div>';
    			}
    			return '&nbsp;';
		    }},
    		{"data":"mac", "title": translation['devices.MAC'], width: "100px", className: "center", "orderable": true},
    		{"data":"phone", "title": translation['devices.Phone'], "orderable": true},
    		{"data":"firmware", "title": translation['devices.Firmware'], className: "center", "orderable": true},
    		{"data":"ntp", "title": translation['devices.NTPOffset'], className: "center", "orderable": true},
    		{"data":"qos", "title": translation['devices.Vlan'], className: "center", "orderable": true},
    		{"data":"token", "title": translation['devices.Token'], width: '240px', className: "center", "orderable": true},
    		{"data":"comment", "title": translation['devices.Comment'], className: "center", "orderable": true},
    		{"data":"islocal", "title": 'Local', "orderable": false, "searchable": false, "visible": false}
		],
		//dom:'<"H"Tl<"toolbar">frB>t<"F"i<"toolbar"B>p>',
		dom: '<"dataTables_top"f>t<"dataTables_bottom"ip<"dataTables_buttons">l<"clear">>',
		data: getDevicesTableDataPrepared(),
		language: dataTableLanguage,
		ajax: {
			url: 'devices/index.php?action=getDeviceList',
	        dataSrc: function (data) {
	        	values = data;
		    	var newData = getDevicesTableDataPrepared();
	        	return newData;
		    }
	    },

	}).on('select', function(event, dt, type, indexes){
		updateButtons(event)
	}).on('deselect', function(event, dt, type, indexes){
		updateButtons(event)
	}).on('dblclick', 'tbody tr', function(event){
		var tr = $(event.target);

		if(tr.hasClass('selected')){
			devicesTable.rows(tr).deselect();
		}else{
			devicesTable.rows(tr).select();
		}
  		$('#editDeviceDialog').dialog('open');
    }).on('click', 'i.fa-play', function(event){
		event.stopPropagation();

		var target = $(event.target);
		var ip = target.data("ip");

    	var tr = $(target).closest('tr');
    	if(tr.hasClass('selected')){
    		devicesTable.rows(tr).deselect();
    	}else{
    		devicesTable.rows(tr).select();
    	}


		$.post( 'devices/index.php', { "action":'generateUrl', "data[]": [ip] }, function (response) {
			var listDevices = response;
			if(ip in listDevices) {
				var html = '<i class="fa fa-stop" title="'+translation['devices.Disconnect']+'" data-ip="'+ ip +'" ></i><a href="'+ listDevices[ip] +'" title="'+translation['devices.Open']+'" class="fa fa-external-link" target="_blank"></a>';
				target.parent().empty().html(html);
			}
		}).fail(function(e) {
			console.log(e);
		});
		return false;
	}).on('click', 'i.fa-stop', function(event){
		//----------------------------- Remove URL
		event.stopPropagation();

		var target = $(event.target);
		var ip = target.data("ip");

		var tr = $(target).closest('tr');
		if(tr.hasClass('selected')){
			devicesTable.rows(tr).deselect();
    	}else{
    		devicesTable.rows(tr).select();
    	}

		$.post( 'devices/index.php', { "action":'removeUrl', "data[]": [ip] }, function (response) {
			var listDevices = response;
			if(!(ip in listDevices)) {
				var html = '<i class="fa fa-play" title="'+translation['devices.Connect']+'" data-ip="'+ ip +'"></i>';
				target.parent().empty().html(html);
			}

		}).fail(function(e) {
			console.log(e);
		});
		return false;
	}).on( 'click', 'a.fa-external-link' ,function (event){
		var tr = $(event.target).closest('tr');

		if(tr.hasClass('selected')){
			devicesTable.rows(tr).deselect();
		}else{
			devicesTable.rows(tr).select();
		}
	});


	var updateButtons = function(e){
		var selectedData = devicesTable.rows({selected: true}).data()
		$.map(selectedAnalyzer(selectedData), function (value, key) {
			$('#' + key).button((value ? 'enable' : 'disable'));
		});
	}

	var registrar;


	$("div.dataTables_buttons").html('<a href="javascript:void(0);" class="selectAll">'+translation['buttons.SelectAll']+'</a><a href="javascript:void(0);" class="deselectAll">'+translation['buttons.DeselectAll']+'</a>');

	$("div.dataTables_buttons a.selectAll").click(function(event){
		var displayedRows = devicesTable.rows(':visible').nodes();
    	devicesTable.rows(displayedRows).select();
	});

	$("div.dataTables_buttons a.deselectAll").click(function(event){
		var displayedRows = devicesTable.rows(':visible').nodes();
    	devicesTable.rows(displayedRows).deselect();
	});


	$(document).on('devicesTable/update', function () {
		//GET selections state
		var lastSelected = devicesTable.rows({selected: true}).data();

		devicesTable.ajax.reload(function(response){
			if(lastSelected.length > 0){
				// set selected
				devicesTable.rows(function(index, row, node){
					if(row.mac){
						var result = $.grep(lastSelected, function(val){
							return row.mac == val.mac;
						});
						return result.length > 0;
					}
					return false;
				}).select();
			}

			$(document).trigger('devicesTable/updated');
            $(document).trigger('fxsTable/update');
            $(document).trigger('wairTable/update');

            $(".ui-tooltip").hide();
		}, false);
	});


	function getDevicesTableDataPrepared() {
		var devicesDataRaw = values.devices["BODY"];
		var dataPrepared = [];

		provDevices = {};
		$.each( devicesDataRaw, function ( index, dataRow ) {

			var vendor = dataRow.vendor,
			  phone = dataRow.username,
			  model = dataRow.model,
			  address = dataRow.address,
			  url = dataRow.url,
			  mac = dataRow.mac,
			  firmware = dataRow.firmware,
			  ntp = $.type( dataRow.ntp ) == 'undefined' ? '' : dataRow.ntp,
			  qos = dataRow.qos,
			  token = dataRow.token,
			  ready = $.type( dataRow.ready ) == 'undefined' ? '' : dataRow.ready,
			  state = null,
			  comment = $.type( dataRow.desc ) == 'undefined' ? '' : dataRow.desc,
			  islocal = $.type( dataRow.islocal ) == 'undefined' ? false : dataRow.islocal;

			// values state convert to string
			if(stateDevices[mac]){
				var st = []
				for(var i = 0; i < stateDevices[mac].length; i ++){
					st.push(stateDevices[mac][i]['p_reg']);
				}
				state = st.join(' \n ');
			}

			//Values for NTP should be inverted
			ntp = ntp.split( ' ' );
			if ($.type(ntp[1]) != 'undefined' ){
				ntp = ntp[1] + ' ' + ntp[0];
			} else{
				ntp = ntp[0];
			}

			provDevices[mac] = address;

			dataPrepared.push({
				ready: ready,
				state: state,
				vendor: vendor,
				model: model,
				address: address,
				url: url,
				mac: mac,
				phone: phone,
				firmware: firmware,
				ntp: ntp,
				qos: qos,
				token: token,
				comment: comment,
				islocal: islocal
			});

		});
		return dataPrepared;
	}

	function getDeviceConfiguration( mac, ip ) {
		var result = {};
		$.each(values.devices["BODY"], function (index, oneDevice) {
			if ($.type(oneDevice.mac) != 'undefined' && $.type(oneDevice.address) != 'undefined' && oneDevice.mac == mac && oneDevice.address == ip) {
				result = oneDevice;
				return;
			}
		});
		return result;
	}


	function selectedAnalyzer( selectedData ) {  // Return info about which buttons should be enabled
		var buttonsInfo = { //Key values should be similar to button ids
			  'editDevices':true,
			  'removeDevices':true,
			  'assignToUser':true,
			  'resetPassword': false,
			  'configureSync':true,
			  'generateUrl': false,
			  'removeUrl': false
		  },
		  assignableModels = ['phone', 'wp400', 'wp480g', 'wp490g', 'wp410', 'wp410r2', 'wp480', 'wp480r2', 'wp480gr2', 'wp480gr3', 'wp490', 'wp490r2', 'wp490gr2', 'wp490gcr2', 'wp490gr3', 'wp490gr4', 'wp500', 'wp600', 'w01fxs', 'w01fxsr2', 'w-pa', 'wizyconf'];

		//if nothing selected all buttons should be disabled
		if (selectedData.length == 0){
			return {
				'editDevices':false,
				'removeDevices':false,
				'assignToUser':false,
				'resetPassword': false,
				'configureSync':false,
				'generateUrl': false,
				'removeUrl': false
			};
		}

		$.each(selectedData, function (index, oneDataRow){
			if (typeof oneDataRow === 'undefined' || !oneDataRow.address || !oneDataRow.mac) {
				buttonsInfo.editDevices = false;
				buttonsInfo.configureSync = false;
			}

			if(typeof oneDataRow != 'undefined'){
				if(oneDataRow.token !== ''){
					buttonsInfo.resetPassword = true;
				}

				if(!oneDataRow.url && oneDataRow.address){
					buttonsInfo.generateUrl = true;
				}

				if(oneDataRow.url){
					buttonsInfo.removeUrl = true;
				}
			}

            if (typeof oneDataRow === 'undefined' || !oneDataRow.mac || !oneDataRow.model || $.inArray(oneDataRow.model, assignableModels) == -1) {
                buttonsInfo.assignToUser = false;
            }
		});

		return  buttonsInfo;
	}


	var deviceSearchTable = $('#deviceSearchTable').DataTable({
		select: true,
		paging: true,
		pageLength: 7,
		searching: true,
		autoWidth: false,
		columns: [ // column header
			{"data":"mac", "title": translation['devices.MAC'], 'width': '150px', "orderable": true},
			{"data":"address", "title": translation['strings.IpAddress'], "orderable": true},
			{"data":"type", "title": translation['devices.Type'], "orderable": true, "render": renderDeviceModel}
		],
		data:[],
		language: dataTableLanguage,
		dom: '<"dataTables_top"f>t<"dataTables_bottom"ip<"dataTables_buttons"><"clear">>'
	  }).on('select', function(event, dt, type, indexes){
		  	var buttons = $("~ .ui-dialog-buttonpane .ui-dialog-buttonset", $("#dialog")).children("button");
			var btnNext = $(buttons[1]);

			if (deviceSearchTable.rows({selected: true}).data().length == 0) {
				btnNext.button("disable");
			} else {
				btnNext.button("enable");
			}
	  	}).on('deselect', function(event, dt, type, indexes){
			var buttons = $("~ .ui-dialog-buttonpane .ui-dialog-buttonset", $("#dialog")).children("button");
			var btnNext = $(buttons[1]);

			if (deviceSearchTable.rows({selected: true}).data().length == 0) {
				btnNext.button("disable");
			} else {
				btnNext.button("enable");
			}
		});


	var deviceManualFinalTable = $( '#deviceManualFinalTable' ).DataTable( {
		select: true,
		paging: true,
		pageLength: 7,
		searching: true,
		autoWidth: false,
		columns: [ // column header
			{"data":"mac", "title": translation['devices.MAC'], 'width': '150px', "orderable": true},
			{"data":"type", "title": translation['devices.Type'], "orderable": true, "render": renderDeviceModel},
			{"data":"url", "title": translation['devices.ProvisioningURL'], "orderable": true}

		],
		data:[],
		language: dataTableLanguage,
		//dom: '<"H"Tlfr>t<"F"ip>'
		dom: '<"dataTables_top"f>t<"dataTables_bottom"ip<"dataTables_buttons"><"clear">>'
	} );


	var deviceSearchFinalTable = $( '#deviceSearchFinalTable' ).DataTable( {
		select: true,
		paging: true,
		pageLength: 7,
		searching: true,
		autoWidth: false,
		columns: [ // column header
			{"data":"mac", "title": translation['devices.MAC'], 'width': '150px', "orderable": true},
			{"data":"address", "title": translation['strings.IpAddress'], "orderable": true},
			{"data":"type", "title": translation['devices.Type'], "orderable": true, "render": renderDeviceModel},
			{"data":"status", "title": translation['devices.Status'], "orderable": true},
		],
		data:[],
		language: dataTableLanguage,
		//dom: '<"H"Tlfr>t<"F"ip>'
		dom: '<"dataTables_top"f>t<"dataTables_bottom"ip<"dataTables_buttons"><"clear">>'
	} );

	function validateMAC( mac ) {
		var regex = /^([0-9a-f]{2}([:]|$)){6}$|^([0-9a-f]{12})$/i;
		if (regex.test(mac)) {
			return true;
		}
		return false;
	}

	function deviceAdd_manualChange() {
		var $this = $( this ),
		  isAllValid = true,
		  isAllEmpty = true,
		  $macFields = $( '#deviceAddManual_macList .manualAddMacField' ),
		  $btnNext = $( "#dialog ~ .ui-dialog-buttonpane .ui-dialog-buttonset" ).children( "button" ).eq( 1 );

		if (validateMAC( $this.val() ) || $this.val() == '') {

			$this.css( 'border-color', '' );

			$macFields.each( function ( index, oneInput ) {
				var value = $( oneInput ).val();

				if ( value != "" ) {
					isAllEmpty = false;
					isAllValid = validateMAC( value );
					if ( !isAllValid )  return;
				}
			});

			if ( isAllValid && !isAllEmpty ){
				$btnNext.button( 'enable' ).removeClass( 'ui-state-hover' );
			} else{
				$btnNext.button( 'disable' );
			}

		} else {
			$btnNext.button( 'disable' );
			$this.css( 'border-color', 'red' );
		}
	}

	function deviceAddManual_addMAC() {
		var $this = $( this ),
		  $tr = $this.parent().parent(),
		  htmlButtonMinus = '<input type="button" class="buttonRemoveMac" style="margin-left:3px;"  value="-">',
		  $trNew = $tr.clone( false ).insertAfter( $tr ),
		  $buttonsNew = $trNew.find( "input:button" ),
		  $inputNew = $trNew.find( "input:text" ).first();

		$inputNew.on( "keyup", deviceAdd_manualChange );

		if ( $buttonsNew.length == 1 ) {
			$( htmlButtonMinus ).insertAfter( $buttonsNew.first().removeClass( 'ui-state-hover' ).button().on( "click", deviceAddManual_addMAC ) ).button().on( "click", deviceAddManual_removeMAC );
		} else {
			$buttonsNew.eq( 0 ).removeClass( 'ui-state-hover' ).button().on( "click", deviceAddManual_addMAC );
			$buttonsNew.eq( 1 ).button().on( "click", deviceAddManual_removeMAC );
		}

	}

	function deviceAddManual_removeMAC() {
		var $this = $(this);
		var $tr = $this.parent().parent();
		$tr.remove();
	}

	$( '.buttonAddMac' ).button().on("click", deviceAddManual_addMAC );
	$( '.buttonRemoveMac' ).button().on("click", deviceAddManual_removeMAC );
	$( '.manualAddMacField' ).on("keyup", deviceAdd_manualChange );




	var removeDevicesConfirmButtons = {};
	removeDevicesConfirmButtons[translation['buttons.Delete']] = function () {
		var data = [];
		var selectedDevices = devicesTable.rows({selected: true}).data();

		$(selectedDevices).each(function(index, oneDevice) {
			data.push({
				'mac': oneDevice.mac,
				'address': oneDevice.address,
				'username': oneDevice.phone
			});
		});

		if (data.length > 0) {
			$.ajax( {
				type:'GET',
				url:'devices/index.php',
				dataType:"json",
				data:{
					action: "removeDevices",
					settings: data
				},
				success:function () {
					$(document).trigger('devicesTable/update');
				}
			});
		}
		$(this).dialog("close");
	}

	removeDevicesConfirmButtons[translation['buttons.Cancel']] = function () {
		$(this).dialog("close");
	}

	$("#removeDevicesConfirm").dialog({
		resizable: false,
		height: 230,
		modal: true,
		autoOpen: false,
		buttons: removeDevicesConfirmButtons
	});







	function correctEditDeviceDialogFields(model){

		var fields = ['dialtone', 'tonezone', 'snmp', 'sip_firewall'];

		for(var i=0; i < fields.length; i++){
			if(!availableDeviceSettings.hasOwnProperty(model) ||
				!availableDeviceSettings[model].hasOwnProperty(fields[i]) ||
				availableDeviceSettings[model][fields[i]] === false){

					$('#'+fields[i]).hide();
			}
		}
	}

	function editDeviceDialogOpen() {
		$('#dialtone').show();
		$('#tonezone').show();
		$('#stat_tonezone').next().children().eq( 0 ).val( '' );
		$('#snmp').show();
		$('#sip_firewall').show();

		var selectedData = devicesTable.rows({selected: true}).data();
		var dataLength = selectedData.length;
		var $this = $( this );
		var configurationOptions = ['ntp_server', 'ntp_timezone', 'vid_voice', 'vid_data', 'qos_voice', 'qos_data', 'use_tls', 'use_dst', 'use_static_ip', 'dns_server', 'second_dns_server', 'syslog_server', 'snmp_access', 'disable_sip_firewall'];
		var staticOptions = ['dialtone', 'tonezone'];
		var fxs_devices = {
				  'w04fxs' : 'welltech',
				  'w08fxs' : 'media5',
				  'w16fxs' : 'media5',
				  'w24fxs' : 'media5',
				  'w02fxsr3' : 'dinstar2',
				  'w04fxsr3' : 'dinstar2',
				  'w24fxsr3' : 'dinstar2',
				  'w08fxsr2' : 'dinstar2',
				  'w16fxsr2' : 'dinstar2',
				  'w24fxsr2' : 'dinstar2'
		  }


		 // console.log('selectedData',selectedData);
		//---------------------General reset---------------
		$.each(configurationOptions, function (index, item){
			$ditem = $('#dev_' + item);
			$citem = $('#dev_' + item + '_enabled');

			$ditem.prop("disabled", true).removeClass("ui-state-default").addClass("ui-state-disabled" );
			if (item == 'use_dst') {
				$citem.prop('checked', true);
			}else{
				$citem.prop('checked', false);
			}
			$ditem.val('');
			if (item == 'qos_voice' || item == 'qos_data') {  //This is slider
				$('#dev_' + item + '_slider').slider('disable');
				$('#dev_' + item + '_slider').slider({value:0});
				$('#dev_' + item + '').html(0);
			}

			if (item == 'ntp_timezone') {    // This is combobox
				var $comboboxSpan = $ditem.next(),
				  $comboboxInput = $comboboxSpan.children().eq(0),
				  $comboboxLink = $comboboxSpan.children().eq(1);

				$comboboxInput.prop("disabled", true).removeClass("ui-state-default").addClass("ui-state-disabled").val('').trigger('change');
				$comboboxLink.button('disable');
			}
		});

		//-------------------------------------------------

		if (dataLength == 1) {
			var ip = selectedData[0].address;
			var mac = selectedData[0].mac;
			var extention = selectedData[0].phone;
			var model = selectedData[0].model;
			var comment = selectedData[0].comment;
			var configuration = getDeviceConfiguration(mac, ip);

			registrar = configuration.registrar; // push value for every open edit window
			correctEditDeviceDialogFields(model);

			$('#dev_comment').val(comment);
			$('#dev_macs').val(mac);
			$('#dev_ips').val(ip);
			$('#dev_extens').val(extention);
			$('#dev_models').val(model);

			if (configuration.settings) {
				$.each(staticOptions, function(index, item) {
					if ($('#' + item).is(':visible')) {
						var value = configuration.settings[item];
						if (item == 'tonezone'){			 // This is combobox
							$( '#stat_' + item ).next().children().eq( 0 ).val( $( 'option[value="' + value + '"]' ).text() );
						}
					}
				});
				$.each( configurationOptions, function( index, item ) {
					if ( $ditem = $( '#dev_' + item ) ) {
						var value = configuration.settings[item];
						if ($citem = $( '#dev_' + item + '_enabled' )){
							if ( item == 'qos_voice' || item == 'qos_data' ) {
								if ( !!value ) {
									$( '#dev_' + item + '_slider' ).slider( 'enable' );
									$( '#dev_' + item + '_slider' ).slider( {value:value} );
									$( '#dev_' + item + '' ).html( value );
								} else {
									$( '#dev_' + item + '_slider' ).slider( 'disable' );
									$( '#dev_' + item + '_slider' ).slider( {value:0} );
									$( '#dev_' + item + '' ).html( 0 );
								}
							}

							if ( item == 'ntp_timezone' ) {    // This is combobox
								var $comboboxSpan = $ditem.next(),
								  $comboboxInput = $comboboxSpan.children().eq( 0 ),
								  $comboboxLink = $comboboxSpan.children().eq( 1 );

								if ( !!value ) {
									var tz = value.split('/');
									$comboboxInput.val(tz[0]).trigger( 'change' );
									$comboboxInput.prop( "disabled", false ).removeClass( "ui-state-disabled" ).addClass( "ui-state-default" );
									$comboboxLink.button( 'enable' );
									$ditem2 = $( '#dev_' + item + '2' );
									$ditem2.next().show();
									$ditem2.next().children().eq( 0 ).val(tz[1]).trigger( 'change' );
								} else {
									$comboboxInput.prop( "disabled", true ).removeClass( "ui-state-default" ).addClass( "ui-state-disabled" );
									$comboboxLink.button( 'disable' );
								}
							}

							if ( item == 'use_static_ip' && value == 0 ) {
								$citem.prop( 'checked', true );
							} else if ( item == 'use_dst') {
								if(value == 'no'){
									$citem.prop( 'checked', false );
								}
							}else{
								$citem.prop( 'checked', !!value );
								if ( !!value ) {
									$ditem.prop( "disabled", false ).removeClass( "ui-state-disabled" ).addClass( "ui-state-default" );
								} else {
									$ditem.prop( "disabled", true ).removeClass( "ui-state-default" ).addClass( "ui-state-disabled" );
								}
							}
						}
						if ( !!value ) {
							$ditem.val( value );
						} else {
							$ditem.val( '' );
						}
					}
				});
			}
		} else { //if there is more than 1 device selected
			var ip = [], mac = [], extention = [], model = [], useVendor, useModel;
			registrar = null; // clear global variable for multi edit

			$.each( selectedData, function ( index, value ) {
				ip.push(value.address);
				mac.push(value.mac);
				extention.push(value.phone);
				useModel = value.model;
				model.push(useModel);

				correctEditDeviceDialogFields(useModel);

				if ( useModel && useVendor != 'blocked' ) {
					if ( useVendor == fxs_devices[useModel] || !useVendor ){
						useVendor = fxs_devices[useModel] || 'blocked';
					}else{
						useVendor = 'blocked';
					}
				}
			} );

			if ( useVendor && useVendor != 'blocked' ){
				setDialtoneList ( useVendor );
			}

			$( '#dev_macs' ).val( mac.join( '|' ) );
			$( '#dev_ips' ).val( ip.join( '|' ) );
			$( '#dev_extens' ).val( extention.join( '|' ) );
			$( '#dev_models' ).val( model.join( '|' ) );
		}
	}

	$( "#editDeviceDialog input:checkbox" ).on( 'click', function () {

		var $this = $( this ),
		  $td = $this.parent().next(),
		  $slider,
		  $input,
		  $combobox;

		$slider = $td.find( 'div' );
		$combobox = $td.find( 'span' );
		$input = $td.find( 'input:text' );

		if ( $this.is( ':checked' ) ) {
			if ( $this.attr('id') == 'dev_syslog_server_enabled' && !!registrar) {
				$input.val(registrar);
			}

			if ( $slider.length )
				$slider.slider( 'enable' );
			else
				$input.prop('disabled', false ).removeClass( "ui-state-disabled" ).addClass( "ui-state-default" );

			if ( $combobox )
				$combobox.children().eq( 1 ).button( 'enable' );
		} else {
			if ( $slider.length )
				$slider.slider( 'disable' );
			else
				$input.prop("disabled", true).removeClass( "ui-state-default" ).addClass( "ui-state-disabled" );
			if ( $combobox ) {
				$combobox.children().eq( 1 ).button( 'disable' );
			}
		}
	} );

	var editDeviceDialogButtons = {};
	editDeviceDialogButtons[translation['buttons.Save']] = function ( e ) {
		var configurationOptions = ['comment', 'ntp_server', 'ntp_timezone', 'vid_voice', 'vid_data', 'qos_voice', 'qos_data', 'use_tls', 'use_static_ip', 'use_dst', 'dns_server', 'second_dns_server', 'syslog_server', 'snmp_access', 'disable_sip_firewall', 'macs', 'ips', 'extens', 'models'];
		var staticOptions = ['dialtone', 'tonezone'];
		var objectToSend = {};

		$.each( staticOptions, function( index, item ) {
			if ( $( '#' + item ).is(':visible') ) {
				var selText = $( '#stat_' + item ).next().children().eq( 0 ).val();
				if ( !!selText )
					objectToSend[item] = $( '#stat_' + item + '> option:contains("' + selText + '")').val();
			}
		});
		$.each( configurationOptions, function( index, item ) {
			var $valueContainer = $( '#dev_' + item );
			var optionStatus = $( '#dev_' + item + '_enabled' ).is( ':checked' );
			var value = $valueContainer.val();

			if ( item == 'use_static_ip' ) value = optionStatus ? 1 : 0;
			if ( item == 'disable_sip_firewall' ) value = optionStatus ? 1 : 0;
			if ( item == 'use_dst' ) value = optionStatus ? "yes" : "no";
			if ( item == 'qos_data' || item == 'qos_voice' ) value = $valueContainer.html();
			if ( item == 'macs' || item == 'ips' || item == 'extens' || item == 'models' ) optionStatus = true;
			if ( item == 'ntp_timezone' ){
				// fix from combobox value
				value = $( '#dev_' + item ).next().children().eq( 0 ).val() + '/' + ($( '#dev_' + item + '2').next().children().eq( 0 ).val() || '');
			}

			if (optionStatus || item == 'use_dst') {
				objectToSend[item] = value;
			}
		});

		$.post( 'devices/index.php', {"action":'setDevice', 'settings':JSON.stringify( objectToSend )}, function () {
            setTimeout(function () { $( document ).trigger( 'devicesTable/update' ); }, 1500); //Update table after 1,5 seconds
		});
		$( this ).dialog("close");
	}

	editDeviceDialogButtons[translation['buttons.Cancel']] = function () {
		$( this ).dialog( "close" );
	}

	$( "#editDeviceDialog" ).dialog( {
		height:'auto',
		width:400,
		modal:true,
		resizable:false,
		autoOpen:false,
		open:editDeviceDialogOpen,
		buttons: editDeviceDialogButtons
	} );

	function assignToUserDialogOpen() {

		var selectedData = devicesTable.rows({selected: true}).data();
		var dataLength = selectedData.length;
		var $this = $(this);
		var html = '<table style="width:100%">';

		$.each(selectedData, function(index, oneDataRow) {
			var model = oneDataRow.model;
			var mac = oneDataRow.mac;
			var phone = oneDataRow.phone;
			var ip = oneDataRow.address ? oneDataRow.address : '';

			html += '<tr>';
			if ( dataLength == 1 ) {  //different behaviour if only one Device selected
				html += '<td width="110px">'+translation['devices.Phone']+'</td><td>&nbsp;</td>';
			} else {
				html += '<td>' + model + ':</td><td>' + mac + '</td>';
			}

			html += '<td class="saveUserData"><input type="text" class="autoLoadUser ui-corner-all" style="width:250px" value="'+($.isNumeric(phone)?phone:'Unknown')+'"><span class="resLoadUser" style="font-size:11px; color:#666; padding-left:5px;">&nbsp;&nbsp;</span><input type="hidden" class="newUs"><input type="hidden" class="oldUs" value="' + ip + '_' + model + '_' + phone + '_' + mac + '" /></td>';
			html += '</tr>';
		});
		html += '</table>';
		$this.html( html );

		$( ".autoLoadUser" ).blur(function(e){
			if($(e.target).val() == ''){
				$(e.target).val('Unknown');
				$(e.target).parent().find(".newUs").val('unknown');
            }
		});
		$( ".autoLoadUser" ).focus(function(e){
			if($(e.target).val() == 'Unknown'){
				$(e.target).val('');
            }
			$(e.target).autocomplete('search',$(e.target).val());
		})

		var count = '';

		$( ".autoLoadUser" ).autocomplete({
		      source: function( request, response ) {

		    	var el = this.element;
		    	el.css('border-color', '#ccc');
		    	var elParent = el.parent();
		    	el.val(el.val().replace(/<|>|#|\*|%|\[|\(|;/g, ''));
		    	request.term = el.val();
		        $.ajax({
		          url: "devices/index.php?action=getUsersList",
		          dataType: "json",
		          data: {
		            text: request.term
		          },
		          success: function( data ) {
		        	elParent.find(".newUs").val('');
		        	elParent.find(".resLoadUser").html('');
		        	if(data['count']){
		          		count = data['count'];
			          	delete data['count'];
		          	}else {
		          		count = '';
		          	}

		        	var users = [{
	        			label: 'Unknown',
	        			value: 'unknown'
	        		}];

		        	if(data != ''){
		        		$.each(data, function(key, item){
			        		users.push({
			        			label: item,
			        			value: key
			        		});
			        	});
		        	}


		          	response(users);
		          }.bind(this)
		        });
		      },
		      minLength: 0,
		      select: function( event, ui ) {
		    	  $(this).val(ui.item.label);

		    	  $(this).parent().find(".newUs").val(ui.item.value? ui.item.value : '') ;

		    	  $(this).parents('.ui-dialog').find('button').eq(0).focus();
		    	  return false;
		      },
		      open: function() {
		        $( this ).removeClass( "ui-corner-all" ).addClass( "ui-corner-top" );
		        $('.ui-autocomplete').removeClass( "ui-corner-all" ).addClass( "ui-corner-bottom" );
		        $( this ).parent().find(".resLoadUser").html(count);
		      },
		      close: function() {
		    	$( this ).parent().find(".resLoadUser").html('');
		        $( this ).removeClass( "ui-corner-top" ).addClass( "ui-corner-all" );
		        $('.ui-autocomplete').removeClass( "ui-corner-bottom" ).addClass( "ui-corner-all" );
		      },
		      delay: 500
		  });
	}

	var assignToUserDialogButtons = {};
	assignToUserDialogButtons[translation['buttons.Save']] = function ( e ) {

		var $dataCells = $( '#assignToUserDialog .saveUserData' );
		flashError();
		$dataCells.each(function(index, oneUser) {

			var oldInfo = $('input.oldUs', oneUser ).val().split( '_' ),
			  ip = oldInfo[0] ? oldInfo[0] : '',
			  model = oldInfo[1],
			  oldExtention = oldInfo[2],
			  mac = oldInfo[3],
			  selectedValue = $('input.newUs', oneUser).val(),
			  inputValue = $('input.autoLoadUser', oneUser).val();

			if (selectedValue == '' && inputValue != 'Unknown'){
				selectedValue = inputValue.replace(/[^0-9]/g, '');
			}

			if ( selectedValue != '' && selectedValue ) {
				if(inputValue === 'Unknown') {
					if (model === 'wizyconf') {
						$('input.autoLoadUser', oneUser).css('border-color', 'red');
						ap_showWaitMessage('waitDiv', 0);
						return
					}
					$.post( 'devices/index.php',
							{"action":'setUser', 'settings':JSON.stringify( {"address":ip, 'model':model, 'extenNumber':selectedValue, '_extenNumber':oldExtention, 'mac': mac} )},
							 function () {
								$( document ).trigger('devicesTable/update');
								ap_showWaitMessage('waitDiv', 0);
								$( this ).dialog( "close" );
	                }.bind(this));
				}else{
					$.ajax({
				          url: "devices/index.php?action=getUsersByPhone",
				          dataType: "json",
				          data: {
				            phone: selectedValue
				          },
				          success: function( data ) {
				          	if(data){
				          		$.post( 'devices/index.php',
										{"action":'setUser', 'settings':JSON.stringify( {"address":ip, 'model':model, 'extenNumber':selectedValue, '_extenNumber':oldExtention, 'mac': mac} )},
										 function () {
											$( document ).trigger('devicesTable/update');

											ap_showWaitMessage('waitDiv', 0);
											$( this ).dialog( "close" );
				                }.bind(this));
				          	}else {
				          		$('input.autoLoadUser', oneUser).css('border-color', 'red');
				          		$( 'input.newUs', oneUser ).val('');

				        		ap_showWaitMessage('waitDiv', 0);
				          	}
				          }.bind(this)
				    });
				}

			}else if(inputValue.length){
				$('input.autoLoadUser', oneUser).css('border-color', 'red');
				ap_showWaitMessage('waitDiv', 0);
			}
		}.bind(this));
	}

	assignToUserDialogButtons[translation['buttons.Cancel']] = function () {
		$(this).dialog( "close" );
	}

	$("#assignToUserDialog").dialog({
		height:330,
		width:530,
		modal:true,
		resizable:false,
		autoOpen:false,
		open:assignToUserDialogOpen,
		buttons:assignToUserDialogButtons
	});

	var dialogButtons = {};
	dialogButtons[translation['buttons.Prev']] = function ( e ) {

		if ( $( '#addDevice_configureMode' ).is( ':checked' ) ) {
			wizardSearch.prev( e.target );
		} else {
			wizardManual.prev( e.target );
		}
	}

	dialogButtons[translation['buttons.Next']] = function ( e ) {
		if ( $( '#addDevice_configureMode' ).is( ':checked' ) ) {
			wizardSearch.next( e.target );
		} else {
			wizardManual.next( e.target );
		}
	}

	dialogButtons[translation['buttons.Cancel']] = function () {
		$( this ).dialog( "close" );
	}

	var dialogOpen = function(event, ui){
		var ips='';
		if(networkInterfaces){
			if(networkInterfaces['eth0'] && networkInterfaces['eth0']['activate'] == 'UP' && networkInterfaces['eth0']['network'] != '0.0.0.0'){
				ips=networkInterfaces['eth0']['network']+'-'+'254'
			}

			if(networkInterfaces['eth1'] && networkInterfaces['eth1']['activate'] == 'UP' && networkInterfaces['eth1']['network'] != '0.0.0.0'){
				if(ips!=''){
					ips+=', ';
				}
				ips+=networkInterfaces['eth1']['network']+'-'+'254'
			}
		}

		$('#deviceAddIPRange').val(ips);
		$('#ui-widget-overlay').css('backround','#fff');
	}

	var dialogClose = function( event, ui ) {
		wizardSearch.reset();
		wizardManual.reset();
	}

	if( Prototype.Browser.IE){

		dialogClose = function( event, ui ) {
			wizardSearch.reset();
			wizardManual.reset();
			jQuery( "#dialog" ).dialog( "destroy" );
		}

		function openDialogIE() {

			jQuery( "#dialog" ).dialog( {
				height:560,
				width:800,
				modal:true,
				autoOpen:false,
				resizable:false,
				buttons:dialogButtons,
				close: dialogClose,
				open: dialogOpen
			} );
			jQuery('#dialog').css('padding','0');

			wizardSearch = new DeviceWizard(jQuery('#dialog'), 'search');
			wizardManual = new DeviceWizard(jQuery('#dialog'), 'manual');

			jQuery('#dialog').dialog('open');
		}

	} else{

		jQuery( "#dialog" ).dialog( {
			height:560,
			width:800,
			modal:true,
			autoOpen:false,
			resizable:false,
			buttons:dialogButtons,
			close: dialogClose,
			open: dialogOpen
		} );

		wizardSearch = new DeviceWizard( jQuery( '#dialog' ), 'search' );
		wizardManual = new DeviceWizard( jQuery( '#dialog' ), 'manual' );
	}

	jQuery("#addDevice").click(function(){
		if($('#aDWcloud').val()==1){
			$('#addDevice_configureMode').prop('checked', false);
			wizardManual.next();
		}
		if( Prototype.Browser.IE){
			openDialogIE();
		} else {
			jQuery('#dialog').dialog('open');
		}
	});

	$("#dev_qos_voice_slider").slider({
		value:0,
		min:0,
		max:7,
		step:1,
		slide:function ( event, ui ) {
			$("#dev_qos_voice").html(ui.value);
		}
	}).slider('disable');


	$("#dev_qos_data_slider").slider({
		value:0,
		min:0,
		max:7,
		step:1,
		slide:function ( event, ui ) {
			$("#dev_qos_data").html( ui.value );
		}
	}).slider('disable');

	$( "#addDevice" ).button( {icons:{primary:'ui-icon-plus', secondary:'ui-icon-newwin'}} )
	  .next().button( {icons:{primary:'ui-icon-pencil', secondary:'ui-icon-newwin'}, disabled:true} )
	  .next().button( {icons:{primary:'ui-icon-trash'}, text:false, disabled:true} ).on( "click", function () {   //Delete button click handler
		  $( '#removeDevicesConfirm' ).dialog( 'open' );
	  })
	  .next().button({icons:{primary:'ui-icon-refresh'}, disabled:true})
	  .next().button({icons:{primary:'ui-icon-person', secondary:'ui-icon-newwin'}, disabled:true})
	  .next().button().on("click", function () {   //Sync from WMP button click handler
		  syncFromWmp();
	  })
	  .next().button({disabled:true}).on("click", function () {   //Reset password button click handler
		  resetPassword();
	  });

	function syncFromWmp(){
		$('#syncFromWMP').button("disable");
		$.ajax( {
			type:'POST',
			url:'/api/v1/Device/Sync/',
			dataType:"json",
			success: function (response, textStatus, jqXHR) {

			},
			error: function(jqXHR, textStatus, errorThrown){
				var error = '';
        		if(jqXHR && jqXHR.responseText){
        			var response = jQuery.parseJSON(jqXHR.responseText);
        			if(response && response['reason']){
        				error = response['reason'];
        			}
        		}
        		console.log('error', error)
			},
			complete:  function(jqXHR, textStatus){
				setTimeout(function(){
					$('#syncFromWMP').button("enable");
					$(document).trigger('devicesTable/update');
				}, 2 * 1000 );
			}
		});
	}

	function resetPassword(){
        var devices = [];

        var selectedData = devicesTable.rows({selected: true}).data()

		$.each(selectedData, function(index, oneDevice) {
			var mac = oneDevice.mac;
			var token = oneDevice.token;

			if(mac && mac != '' && token && token != ''){
				devices.push(mac);
			}
		});

	    if (devices.length > 0) {
	    	devicesTable.rows().deselect();

	    	$.ajax({
				type:'PUT',
				url:'/api/v1/Device/'+devices.join(',')+'/',
				dataType:"json",
				data: {
					data: {
						token: ''
					}
				},
				success: function (response, textStatus, jqXHR) {

				},
				error: function(jqXHR, textStatus, errorThrown){
					var error = '';
	        		if(jqXHR && jqXHR.responseText){
	        			var response = jQuery.parseJSON(jqXHR.responseText);
	        			if(response && response['reason']){
	        				error = response['reason'];
	        			}
	        		}
	        		console.log('error', error)
				},
				complete: function(jqXHR, textStatus){
					$(document).trigger('devicesTable/update');
				}
			});
	    }
	}
	//-----------Next/Previous buttons processing--------------
	function deviceAdd_manualFinal() {

		var allMacs = [];
		var $macList = $('#deviceAddManual_macList input[type="text"]');

		$macList.each(function(index, oneMAC) {
			var macValue = $( oneMAC ).val();
			if ( validateMAC( macValue ) ) {
				allMacs.push(macValue);
			}
		});

		return $.post( 'devices/ajax_semiAutomatic.php', {"macs": allMacs }, function ( data, textStatus ) {
			if(data.length){
				$.each(data, function(index, value){
					deviceManualFinalTable.row.add({
						mac: value[0],
						type: value[1],
						url: value[2]
					});
				});
				deviceManualFinalTable.draw();
			}
			$(document).trigger('devicesTable/update');
		});
	}

	$('#deviceAddIPRange').on('click', function(){
		$(this).css('border-color', '');
	});
	//----------------------------------------------------------

    //We are updating DeviceTable data each 15 seconds
	$(document).trigger('devicesTable/update');
    setInterval( function(){
    	$(document).trigger('devicesTable/update');
    }, 15 * 1000);

	//---------------------Device search final provisioning
    function updateDeviceWizardFinalTable () {

        var finalTableData = deviceSearchFinalTable.rows().data(); // [mac, ip , type, status]
        var isAllProvisioned = true;

        $(finalTableData).each(function (index, value) {
            var config = getDeviceConfiguration( value.mac, value.address );
            if ($.isEmptyObject(config)){
                isAllProvisioned = false;
                return;
            }

            if ($.type(config.mac) !== 'undefined' && $.type(config.address) !== 'undefined' && $.type(config.model) !== 'undefined' && $.type(config.firmware) !== 'undefined' ) {
            	var newValue = deviceSearchFinalTable.row(index).data()

            	newValue.address = $.type( config.address ) !== 'undefined' ? config.address : value.address;
            	newValue.type = $.type( config.model ) !== 'undefined' ? config.model : value.type;
            	newValue.status = translation['devices.Provisioned']; //Change it to _t('Provisioned')

            	deviceSearchFinalTable.row(index).data(newValue);
            }

            if ( value.status == translation['devices.Provisioning'] ) { //Change it to _t('Provisioning...')
                isAllProvisioned = false;
            }
        });

        if ( isAllProvisioned ) {
            $( '#deviceAdd_searchFinalLoader' ).hide();
        }
    }

    $(document).on( 'devicesTable/updated', updateDeviceWizardFinalTable );

	function addDeviceStartProvisioning() {

		var allData = deviceSearchFinalTable.rows().data();
		var dataPrepared = [];

		$(allData).each(function (index, oneDevice) {
			dataPrepared.push({
					"mac": oneDevice.mac,
					"address": oneDevice.address,
					"username":"",
					"model":oneDevice.type
			});
		});

		return $.ajax( {
			type:'POST',
			url:'devices/index.php',
			dataType:"json",
			data:{
				action:"bind",
				data: dataPrepared
			},
			success:function () {
				$('#deviceAdd_searchFinalLoader').show();
			}
		});
	}

	//---------------------- Device -----------------------
	function validateIP( ip ) {
		var regex = /^([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(\.([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])){3}$/;
		return regex.test( ip );
	}

	function validateIPRange( ipRange ) {

		//192.168.0.1
		//192.168.0.1, 192.168.0.2 ...
		//192.168.0.1-255
		//192.168.0.1-192.168.0.255
		//192.168.0.1-255, 192.168.0.3
		//-----------------------------

		var rangesArray = ipRange.split( ',' );
		var isValid = true;

		$(rangesArray ).each( function ( index, oneIP ) {

			oneIP = $.trim( oneIP );
			//if it is one ip just validate it
			if ( oneIP.indexOf( '-' ) == -1 ) {
				if ( !validateIP( oneIP ) ) {
					isValid = false;
					return;
				}
			} else { //if it is an ip-range do some stuff for validation

				var oneRange = oneIP.split( '-' ),
				  startRange = $.trim( oneRange[0] ),
				  endRange = $.trim( oneRange[1] ),
				  startNetwork,
				  endNetwork = '';

				if(oneRange.length != 2 ) {//range should be exact 2 ips
					isValid = false;
					return;
				}

				if(!validateIP(startRange)) {//left side of range should be valid ip
					isValid = false;
					return;
				}

				var lastDotIndex = startRange.lastIndexOf( '.' );
				startNetwork = startRange.substr( 0, lastDotIndex )
				startRange = Number( startRange.substr( lastDotIndex + 1 ) );

				if ( !validateIP( endRange ) ) {

					var regexp = /^([0-9]){1,3}$/;

					if ( !regexp.test( endRange ) || Number( endRange ) <= 0 || Number( endRange ) > 255 || Number( endRange ) <= startRange ) {//if end of range is not valid ip, it should be valid number greater then 0 and smaller then 256
						isValid = false;
						return;
					}
				} else {

					lastDotIndex = endRange.lastIndexOf( '.' );
					endNetwork = endRange.substr( 0, lastDotIndex );
					endRange = Number( endRange.substr( lastDotIndex + 1 ) );

					if ( startNetwork != endNetwork || startRange >= endRange ) {
						//Networks should be same, start range should be greater then end range
						isValid = false;
						return;
					}
				}
			}
		});
		return isValid;
	}


	//----
	$('#deviceAdd_searchDeepScanButton').button().on("click", function(){
		//Caching JQuery objects
		var $deviceAddIPRange = $( '#deviceAddIPRange' ),
		  $deviceAdd_searchDeepScanButton = $( '#deviceAdd_searchDeepScanButton' ),
		  $deviceAdd_searchLoader = $( '#deviceAdd_searchLoader' ),
		  $deviceAdd_searchStopScanButton = $( '#deviceAdd_searchStopScanButton' ),
		  $this = $( this ),
		  deepRequestsHandles = [],
		  totalDeepScansScheduled = 0,
		  deepScansCounter = 0;

		//---------Validation
		if (validateIPRange( $deviceAddIPRange.val())){
			$deviceAddIPRange.css('border-color', '');
		} else {
			$deviceAddIPRange.css('border-color', 'red');
			return;
		}
		//--------------------

		$this.button("disable");
		$deviceAdd_searchDeepScanButton.button("disable");
		$deviceAdd_searchStopScanButton.button("enable");

		deviceSearchTable.clear();
		deviceSearchTable.draw();

		$deviceAdd_searchLoader.show();

		var enableButtons = function() {
			$deviceAdd_searchLoader.hide();
			$this.button("enable");
			$deviceAdd_searchDeepScanButton.button("enable");
			$deviceAdd_searchStopScanButton.off("click.posted");
			$deviceAdd_searchStopScanButton.button("disable");
		}

        function fetching(i) {
            if (i < totalDeepScansScheduled) {
                return $.getJSON('devices/device_verify.php', {
                    "action": "scan",
                    "ip": hosts[i].ip,
                    "port": hosts[i].port,
                    "rawScan": hosts[i].scanType
                }, function (data, textStatus) {

                    if ($.type(data[hosts[i].ip]) !== 'undefined'
                        && $.type(data[hosts[i].ip].mac_addr_str) !== 'undefined'
                        && $.type(data[hosts[i].ip].model) !== 'undefined'
                        && data[hosts[i].ip].mac_addr_str != ''
                        && $.type(data[hosts[i].ip].model) !== ''
                        && !provDevices[data[hosts[i].ip].mac_addr_str]) {
                            var newRow = {
                                mac: data[hosts[i].ip].mac_addr_str,
                                address: hosts[i].ip,
                                type: data[hosts[i].ip].model.toLowerCase()
                            };
                            deviceSearchTable.row.add(newRow);
                            deviceSearchTable.draw();
                    }
                    deepScansCounter++;

                    if (deepScansCounter >= totalDeepScansScheduled) {
                        enableButtons();
                    }
                    deepRequestsHandles.push(fetching(i + 1)); // next iteration
                }).fail(function () {
                    deepScansCounter++;
                    if (deepScansCounter >= totalDeepScansScheduled) {
                        enableButtons();
                    }
                });
            }
        }

        var hosts = [];
		var jqxhr = $.post('devices/ajax_deepSearch.php', {
			"ipRange": $deviceAddIPRange.val()
			},function ( data, textStatus ) {

			if(data.macsDetected.length){
				for(var i = 0; i < data.macsDetected.length; i ++){
					if(!provDevices[data.macsDetected[i][0]]){
						var newRow = {
								mac: data.macsDetected[i][0],
								address: data.macsDetected[i][1],
								type: data.macsDetected[i][2],
						};
						deviceSearchTable.row.add(newRow);
					}
				}
				deviceSearchTable.draw();
			}

            if (data.ipWithPort.length > 0) {
                $.each(data.ipWithPort, function (index, host) {
                    totalDeepScansScheduled++;
                    hosts[index] = {
                        'ip':host.ip,
                        'port':host.port,
                        'scanType':data.rawScan
                    };
                });
                deepRequestsHandles.push(fetching(0)); // start search

            } else {
                enableButtons();
            }
		}).fail(function(){
			  $deviceAdd_searchLoader.hide();
			  $deviceAdd_searchStopScanButton.button( "disable" );
		});

		$deviceAdd_searchStopScanButton.one( "click.posted", function () {
			jqxhr.abort();

			deepScansCounter = totalDeepScansScheduled;
			for (var i in deepRequestsHandles) {
				if (deepRequestsHandles[i]  && $.type(deepRequestsHandles[i].abort) === "function"  ){
					deepRequestsHandles[i].abort();
				}
			}
		});
	});

	$('#deviceAdd_searchStopScanButton').button().button("disable").on("click", function() {
		$('#deviceAdd_searchDeepScanButton').button("enable");
		$('#deviceAdd_searchLoader').hide();
	});


	//---------------------- Configure/sync device --------
	$('#configureSync').on('click', function(){

		var optionsToSend = [];
        var optionsToUpgrade = [];
        var selectedData = devicesTable.rows({selected: true}).data()

		$.each(selectedData, function(index, oneDevice) {
			var mac = oneDevice.mac;
			var address = oneDevice.address;
			var username = oneDevice.phone;
			var model = oneDevice.model;
            var ready = oneDevice.ready;

			if (ready == 'fw') {
                var tmp = getDeviceConfiguration(mac, address);
                var newfw = $.type( tmp.newfw ) === 'undefined' ? '' : tmp.newfw;

                optionsToUpgrade.push({
                	mac: mac,
                    address: address,
                    username: username,
                    model: model,
                    newfw: newfw
                });
            } else {
            	optionsToSend.push({
            		mac: mac,
                    address: address,
                    username: username,
                    model: model
            	});
            }
		});

        if (optionsToSend.length > 0) {
           $.post('devices/index.php', {
        	   action: 'bind',
        	   data: optionsToSend
           }, function() {
        	   devicesTable.rows().deselect();
            });
        }

        if (optionsToUpgrade.length > 0) {
            $.each(optionsToUpgrade, function (index, value) {
                setTimeout(function () {
                	//We should upgrade devices one by one, cause in other way Mediatrix upgrade fails
                    $.post( 'devices/index.php', {
                    	action: 'upgrade',
                    	data: [value]
                    }, function () {
                    	devicesTable.rows().deselect();
                    });

                },  2000 * index); //Starting firmwares upgrades each 2 seconds
            });
        }
	});
	//-----------------------------------------------------
	var tnz_opt;
	$.each(list_tonezone, function(key, value){
		tnz_opt = jQuery('<option/>');
		tnz_opt.attr('value', key);
		tnz_opt.text(value);
		jQuery('#stat_tonezone').append(tnz_opt);
	});

	// timezones from index.tpl.php
	var tz_opt;
	$.each(timezones, function(key, value){
		tz_opt = jQuery('<option/>');
		tz_opt.attr('value', key);
		tz_opt.text(key);
		jQuery('#dev_ntp_timezone').append(tz_opt);
	});

	$("#userToAssign").combobox();
	$("#dev_ntp_timezone").combobox();
	$("#dev_ntp_timezone2").combobox();
	$("#dev_ntp_timezone2").next().hide();
	$("#stat_dialtone").combobox();
	$("#stat_tonezone").combobox();
	$("#tabs").tabs().show();


	var selectedZone = function(){
		var zone = $(this).val();
		$("#dev_ntp_timezone2").val('');
		$("#dev_ntp_timezone2").next().children().eq(0).val('');
		$("#dev_ntp_timezone2").empty();
		if(!!zone){
			$('#dev_ntp_timezone2').next().show();
			// timezones from index.tpl.php
			jQuery.each(timezones[zone], function(key, value){
				tz_opt = jQuery('<option/>');
				tz_opt.attr('value', value);
				tz_opt.text(value);
				$("#dev_ntp_timezone2").append(tz_opt);
			});
		}else{
			$('#dev_ntp_timezone2').next().hide();
		}
	}
	$("#dev_ntp_timezone").on("comboboxselected", selectedZone);
	$("#dev_ntp_timezone").next().children().eq( 0 ).on('change', selectedZone);

    $('#deviceAdd_selectAll').button().on('click', function () {
    	deviceSearchTable.rows().select();
    });


	function DeviceWizard(container, group) {

		this.container = container,
		  this.group = group,
		  this.buttons = $( "~ .ui-dialog-buttonpane .ui-dialog-buttonset", this.container ).children( "button" ),
		  this.btnPrev = $( this.buttons[0] ),
		  this.btnNext = $( this.buttons[1] ),
		  this.btnCancel = $( this.buttons[2] );
		this.slides = $( '> div[data-group*=' + group + ']', container ),
		  this.currentSlide = 0;

		this.slides.hide();

		$( this.container ).dialog( "option", "title", $( this.slides[this.currentSlide] ).data( 'title' ) );
		jQuery(this.container).css('background','#fff');
		$( this.slides[this.currentSlide] ).show();

		this.btnPrev.button( "disable" );
	}

	DeviceWizard.prototype.next = function ( button ) {
		if ( this.currentSlide == 1 ) {

			if ( this.group == 'search' ) { //Automatic provisioning

				var dataToProvision = [];
				var selectedData = deviceSearchTable.rows({selected: true}).data();
				$.each( selectedData, function (index, value) {
					dataToProvision.push({
						mac: value.mac,
						address: value.address,
						type: value.type,
						status: translation['devices.Provisioning']
					});
				});

				deviceSearchFinalTable.clear();
				if(dataToProvision.length){
					deviceSearchFinalTable.rows.add(dataToProvision);
				}
				deviceSearchFinalTable.draw();

				addDeviceStartProvisioning();

				this.btnNext.button().hide();
				this.btnPrev.button().hide();
                this.btnCancel.html( translation['devices.Finish'] );

			} else if ( this.group == 'manual' ) { //Semi-automatic provisioning

				deviceManualFinalTable.clear();
				deviceManualFinalTable.draw();

				deviceAdd_manualFinal();

				this.btnNext.button().hide();
				this.btnPrev.button().hide();
				this.btnCancel.html( translation['devices.Finish'] );

			}
		}

		$( this.slides[this.currentSlide] ).hide();

		$( this.container ).dialog( "option", "title", $( this.slides[++this.currentSlide] ).data( 'title' ) );
		$( this.slides[this.currentSlide] ).show();

		/*if ( this.currentSlide >= this.slides.length - 1 ) {
            $( button ).parent().button().button( "disable" );
		}*/
		if ( this.currentSlide > 0 ) this.btnPrev.button( "enable" );
		if ( this.currentSlide == 1 )  this.btnNext.button( 'disable' );

		if($('#aDWcloud').val()==1){
			this.btnPrev.button().hide();
		}
	}

	DeviceWizard.prototype.prev = function ( button ) {

		$( this.slides[this.currentSlide] ).hide();

		$( this.container ).dialog( "option", "title", $( this.slides[--this.currentSlide] ).data( 'title' ) );
		$( this.slides[this.currentSlide] ).show();

		if ( this.currentSlide <= 0 ) this.btnPrev.button( "disable" );
		if ( this.currentSlide < this.slides.length - 1 ) this.btnNext.button( "enable" );
	}

	DeviceWizard.prototype.reset = function () {

		this.currentSlide = 0;
		this.slides.hide();

		$( this.container ).dialog( "option", "title", $( this.slides[this.currentSlide] ).data( 'title' ) );
		$( this.slides[this.currentSlide] ).show();

		deviceSearchTable.clear();
		deviceSearchTable.draw();

		deviceManualFinalTable.clear();
		deviceManualFinalTable.draw();

		deviceSearchFinalTable.clear();
		deviceSearchFinalTable.draw();

		$('#deviceAddManual_macList tr').each(function(index, oneRow) {
			if ( index == 0 ) {
				$(oneRow).find("input:text").first().val('').trigger('keyup');
				$(oneRow).find("input:button").first().trigger("click");
			} else{
				$(oneRow).remove();
			}
		});

		this.btnNext.button().removeClass( 'ui-state-hover' ).show();
		this.btnPrev.button().show();
		this.btnCancel.html( translation['buttons.Cancel'] ).show();

		this.buttons.button( "enable" );
		this.btnPrev.button( "disable" );
	}
});
